jQuery(document).ready(function($){

  $.fn.isInViewport = function(offset) {
    if(typeof($(this)) !== 'undefined'){
      var elementTop = $(this).offset().top;
      var elementBottom = elementTop + $(this).outerHeight();

      var viewportTop = $(window).scrollTop();
      var viewportBottom = viewportTop + $(window).height();

      return elementBottom > viewportTop + offset && elementTop < viewportBottom - offset;
    }
  };

  function loadLottiePlayer(){
    $('.eafree_lottie').each(function(){
      var $this = $(this);
      var lazyload = $this.data('is_lazyload');
      if($this.isInViewport(100)){
        if(lazyload === 'yes' && $this.find('.lottie_player').length === 0){
          var src = $($this).data('src');
          var speed = $($this).data('speed');
          var loop = $($this).data('loop');
          var autoplay = $($this).data('autoplay');

          $('.player_placeholder', $this).replaceWith('<lottie-player class="lottie_player" src="' + src + '" speed="' + speed  + '" ' + loop + ' ' + autoplay + '></lottie-player>');

        }
      }
    });
  }
  loadLottiePlayer();
  $(window).on('scroll', function(){
    loadLottiePlayer();
  });

  function loadDotLottiePlayer(){
    $('.eafree_dotlottie').each(function(){
      var $this = $(this);
      var lazyload = $this.data('is_lazyload');
      if(lazyload === 'yes' && $this.isInViewport(100)){
        if($this.find('.lottie_player').length === 0){
          var src = $($this).data('src');
          var speed = $($this).data('speed');
          var loop = $($this).data('loop');
          var autoplay = $($this).data('autoplay');

          $('.player_placeholder', $this).replaceWith('<lottie-player class="lottie_player" src="' + src + '" speed="' + speed  + '" ' + loop + ' ' + autoplay + '></lottie-player>');

        }
      }
    });
  }
  loadDotLottiePlayer();
  $(window).on('scroll', function(){
    loadDotLottiePlayer();
  });

  var vertical_accordion = '.eafree_vertical_accordion';

  $(vertical_accordion).on('click', '.tab', function(e) {
    e.preventDefault();
    var is_video = $(this).data('is_video');
    var video_source = $(this).data('video_source');
    var video_width = $(this).data('video_width');
    var video_height = $(this).data('video_height');
    var video_url = $(this).data('video_url');
    var lazyload_video = $(this).data('lazyload_video');
    var iframe = '';

    if(is_video === 'yes' && lazyload_video === 'yes'){
      if(video_source === 'youtube'){
        var iframe = '<iframe ' +
        'width="' + video_width + '"' +
        'height="' + video_height + '"' +
        'src="' + video_url + '"' +
        'title="YouTube video player"' +
        'frameborder="0"' +
        'allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture"' +
        'allowfullscreen' +
        '></iframe>';
      }
      else if(video_source === 'dailymotion'){
        var iframe = '<div style="position:relative;padding-bottom:56.25%;height:0;overflow:hidden;">' +
          '<iframe' +
          'style="width:100%;height:100%;position:absolute;left:0px;top:0px;overflow:hidden"' +
          'frameborder="0"' +
          'type="text/html"' +
          'src="' + video_url + '"' +
          'width="' + video_width + '"' +
          'height="' + video_height + '"' +
          'allowfullscreen' +
          'title="Dailymotion Video Player"' +
          'allow="autoplay"' +
          '>' +
        '</iframe>' +
      '</div>';
      }
      else if(video_source === 'vimeo'){
        var iframe = '<iframe' +
        'src="' + video_url + '"' +
        'width="' + video_width + '"' +
        'height="' + video_height + '"' +
        'frameborder="0"' +
        'allow="autoplay; fullscreen; picture-in-picture"' +
        'allowfullscreen' +
        '>' +
      '</iframe>';
      }
      else if(video_source === 'uploaded'){
        var iframe = '<video' +
        'controls' +
        'src="' + video_url + '"' +
        '>' +
      '</video>';
      }

      if($(this).next('.content').find('.video').find('iframe').length === 0 && $(this).next('.content').find('.video').find('video').length === 0){
        $(this).next('.content').find('.video').append(iframe);
      }
    }

    $(vertical_accordion + ' .content:visible').slideUp(300);
    $(this).next('.content').not(':animated').slideToggle(300);
  });

  //////////////////////////////// nested gallery //////////////////////////
  $('.eafree_nested_gallery').each(function(){
    var $gallery = $(this);
    var $lightbox = $('.eafree_nested_gallery_lightbox', this);
    console.log( $lightbox );
    var index = 0;
    $('> ul > li', $gallery).on('click', function(){
      var subgal_src = $(this).data('subgal_src');
      var lightbox = '';
      for (var i = 0; i < subgal_src.length; i++) {
        lightbox += '<div class="slide" style="left:' + (i * 100) + '%">';
        lightbox += '<img src="' + subgal_src[i] + '"/>';
        lightbox += '</div>';
      }

      $lightbox.append(lightbox);
      $lightbox.addClass('visible');
    });

    var slides = $(this).parent().find('.slide');
    for (var i = 0; i < slides.length; i++) {
      slides.eq(i).css('left', (100 * i) + '%');
    }

    $gallery.on('click', '.eafree_nested_gallery_lightbox .next', function(e){
      e.stopPropagation();
      var slides = $(this).parent().find('.slide');
      if(Math.abs(index) < slides.length - 1){
        index--;
      }
      for (var i = 0; i < slides.length; i++) {
        slides.eq(i).css('left', (100 * (i + index)) + '%');
      }
    });

    $gallery.on('click', '.eafree_nested_gallery_lightbox .prev', function(e){
      e.stopPropagation();
      var slides = $(this).parent().find('.slide');
      if(index < 0){
        index++;
      }
      for (var i = 0; i < slides.length; i++) {
        slides.eq(i).css('left', (100 * (i + index)) + '%');
      }
    });

    $gallery.on('click', '.eafree_nested_gallery_lightbox .close', function(e){
      e.stopPropagation();
      $(this).parent().removeClass('visible');
      $(this).parent().find('.slide').remove();
    });

  });

});// end doc ready
