<?php
namespace ElementaryAddons\Utils;

use Elementor\Controls_Manager;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly



class EAFREE_Dynamic_Tag{

	public function get_dynamic_tag_controls( $obj, $prefix, $before_after_type, $condition_arr ){
		$obj->add_control(
			$prefix . '_dynamic_tag_type',
			[
				'label' => esc_html__( 'Select Tag', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [

					'post'  => esc_html__( '//////////// POST ////////////', 'elementary-addons' ),
					'post_custom_field'  => esc_html__( 'Post Custom Field', 'elementary-addons' ),
					'post_id' => esc_html__( 'Post ID', 'elementary-addons' ),
					'post_terms' => esc_html__( 'Post Terms', 'elementary-addons' ),
					'post_time' => esc_html__( 'Post Time', 'elementary-addons' ),
					'post_title' => esc_html__( 'Post Title', 'elementary-addons' ),
					'post_url' => esc_html__( 'Post URL', 'elementary-addons' ),
					'post_category' => esc_html__( 'Post Category', 'elementary-addons' ),

					'archivesp'  => esc_html__( '', 'elementary-addons' ),
					'archive'  => esc_html__( '//////////// ARCHIVE ////////////', 'elementary-addons' ),
					'archive_description'  => esc_html__( 'Archive Description', 'elementary-addons' ),
					'archive_meta' => esc_html__( 'Archive Meta', 'elementary-addons' ),
					'archive_title' => esc_html__( 'Archive Title', 'elementary-addons' ),
					'archive_url' => esc_html__( 'Archive URL', 'elementary-addons' ),

					'sitesp'  => esc_html__( '', 'elementary-addons' ),
					'site'  => esc_html__( '//////////// SITE ////////////', 'elementary-addons' ),
					'page_title'  => esc_html__( 'Page Title', 'elementary-addons' ),
					'site_title' => esc_html__( 'Site Title', 'elementary-addons' ),
					'site_tagline' => esc_html__( 'Site Tagline', 'elementary-addons' ),
					'current_datetime' => esc_html__( 'Current Date Time', 'elementary-addons' ),
					'request_parameter' => esc_html__( 'Request Parameter', 'elementary-addons' ),
					'shortcode' => esc_html__( 'Shortcode', 'elementary-addons' ),
					'user_info' => esc_html__( 'User Info', 'elementary-addons' ),
					'site_url' => esc_html__( 'Site URL', 'elementary-addons' ),
					'internal_url' => esc_html__( 'Internal URL', 'elementary-addons' ),

					'mediasp'  => esc_html__( '', 'elementary-addons' ),
					'media'  => esc_html__( '//////////// MEDIA ////////////', 'elementary-addons' ),
					'featured_image_data'  => esc_html__( 'Featured Image Data', 'elementary-addons' ),

					'authorsp'  => esc_html__( '', 'elementary-addons' ),
					'author'  => esc_html__( '//////////// AUTHOR ////////////', 'elementary-addons' ),
					'author_info'  => esc_html__( 'Author Info', 'elementary-addons' ),
					'author_meta' => esc_html__( 'Author Meta', 'elementary-addons' ),
					'author_name' => esc_html__( 'Author Name', 'elementary-addons' ),
					'author_url' => esc_html__( 'Author URL', 'elementary-addons' ),

					'commentssp'  => esc_html__( '', 'elementary-addons' ),
					'comments'  => esc_html__( '//////////// COMMENTS ////////////', 'elementary-addons' ),
					'comments_number'  => esc_html__( 'Comments Number', 'elementary-addons' ),
					'comments_url' => esc_html__( 'Comments URL', 'elementary-addons' ),

					'woocommercesp'  => esc_html__( '', 'elementary-addons' ),
					'woocommerce'  => esc_html__( '//////////// WOOCOMMERCE ////////////', 'elementary-addons' ),
					'woocommerce_product_price'  => esc_html__( 'Product Price', 'elementary-addons' ),
					'woocommerce_product_rating' => esc_html__( 'Product Rating', 'elementary-addons' ),
					'woocommerce_product_sale' => esc_html__( 'Product Sale', 'elementary-addons' ),
					'woocommerce_product_short_description' => esc_html__( 'Product Short Decription', 'elementary-addons' ),
					'woocommerce_product_sku' => esc_html__( 'Product SKU', 'elementary-addons' ),
					'woocommerce_product_stock' => esc_html__( 'Product Stock', 'elementary-addons' ),
					'woocommerce_product_terms' => esc_html__( 'Product Terms', 'elementary-addons' ),
					'woocommerce_product_title' => esc_html__( 'Product Title', 'elementary-addons' ),
				],
				'default' => 'post_time',
				'condition' => $condition_arr,
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_custom_field_name',
			[
				'label' => esc_html__( 'Custom Field Name', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'post_custom_field' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_custom_field_post_id',
			[
				'label' => esc_html__( 'Post ID', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'post_custom_field' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_post_terms_post_id',
			[
				'label' => esc_html__( 'Post ID', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'post_terms' ], $condition_arr ),
			]
		);

		$taxs = get_taxonomies();
    $taxs_options = [];
    foreach( $taxs as $t ){
      $taxonomy = get_taxonomy( $t );
      $tax_title = $taxonomy->labels->name;
      $taxs_options[$t] = esc_html__( $tax_title, 'elementary-addons' );
    }
		$obj->add_control(
			$prefix . '_dynamic_tag_post_terms_taxonomy',
      [
        'label' => esc_html__( 'Taxonomy', 'elementary-addons' ),
        'type' => \Elementor\Controls_Manager::SELECT,
        'options' => $taxs_options,
        'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'post_terms' ], $condition_arr ),
      ]
    );


		$obj->add_control(
			$prefix . '_dynamic_tag_post_terms_separator',
			[
				'label' => esc_html__( 'Separator', 'elementary-addons' ),
				'type' => Controls_Manager::TEXT,
				'default' => ', ',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'post_terms' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_post_terms_link',
			[
				'label' => esc_html__( 'Link', 'elementary-addons' ),
				'type' => Controls_Manager::SWITCHER,
				'default' => 'yes',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'post_terms' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_post_time_post_id',
			[
				'label' => esc_html__( 'Post ID', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'post_time' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_post_time_type',
			[
				'label' => esc_html__( 'Post Time', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [

					'post_date'  => esc_html__( 'Created', 'elementary-addons' ),
					'post_modified'  => esc_html__( 'Modified', 'elementary-addons' ),
				],
				'default' => 'post_modified',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'post_time' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_post_title_post_id',
			[
				'label' => esc_html__( 'Post ID', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'post_title' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_post_url_post_id',
			[
				'label' => esc_html__( 'Post ID', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'post_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_post_url_is_link',
			[
				'label' => esc_html__( 'Make Link', 'elementary-addons' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Yes', 'elementary-addons' ),
				'label_off' => esc_html__( 'No', 'elementary-addons' ),
				'return_value' => 'yes',
				'default' => '',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'post_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_post_url_link_target',
			[
				'label' => esc_html__( 'Link Target', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [

					'_parent'  => esc_html__( 'New Window', 'elementary-addons' ),
					'_blank'  => esc_html__( 'The same window', 'elementary-addons' ),
				],
				'default' => '_parent',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'post_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_post_url_choose_content',
			[
				'label' => esc_html__( 'Link Content', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [

					'link'  => esc_html__( 'Link', 'elementary-addons' ),
					'custom'  => esc_html__( 'Custom', 'elementary-addons' ),
				],
				'default' => 'link',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'post_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_post_url_content',
			[
				'label' => esc_html__( 'Link Text', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXTAREA,
				'rows' => 5,
				'placeholder' => esc_html__( 'Link text...', 'elementary-addons' ),
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'post_url', $prefix . '_dynamic_tag_post_url_choose_content' => 'custom' ], $condition_arr ),
			]
		);


		$obj->add_control(
			$prefix . '_dynamic_tag_post_category_post_id',
			[
				'label' => esc_html__( 'Post ID', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'post_category' ], $condition_arr ),
			]
		);

		$post_types = [];
		$post_types_args = array(
			'public' => true,
			'exclude_from_search' => false,
		);
		$get_post_types = get_post_types( $post_types_args );
		foreach ( $get_post_types as $key => $val ) {
			$post_types[$key] = esc_html__( $val, 'elementary-addons' );
		}

		$obj->add_control(
			$prefix . '_dynamic_tag_archive_url_post_type',
			[
				'label' => esc_html__( 'Post Type', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => $post_types,
				'default' => '',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'archive_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_archive_url_is_link',
			[
				'label' => esc_html__( 'Make Link', 'elementary-addons' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Yes', 'elementary-addons' ),
				'label_off' => esc_html__( 'No', 'elementary-addons' ),
				'return_value' => 'yes',
				'default' => '',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'archive_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_archive_url_link_target',
			[
				'label' => esc_html__( 'Link Target', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [

					'_parent'  => esc_html__( 'New Window', 'elementary-addons' ),
					'_blank'  => esc_html__( 'The same window', 'elementary-addons' ),
				],
				'default' => '_parent',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'archive_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_archive_url_choose_content',
			[
				'label' => esc_html__( 'Link Content', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [

					'link'  => esc_html__( 'Link', 'elementary-addons' ),
					'custom'  => esc_html__( 'Custom', 'elementary-addons' ),
				],
				'default' => 'link',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'archive_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_archive_url_content',
			[
				'label' => esc_html__( 'Link Text', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXTAREA,
				'rows' => 5,
				'placeholder' => esc_html__( 'Link text...', 'elementary-addons' ),
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'archive_url', $prefix . '_dynamic_tag_archive_url_choose_content' => 'custom' ], $condition_arr ),
			]
		);

		$pages = [];
		$page_ids= get_all_page_ids();
		for ( $i = 0; $i < count( $page_ids ); $i++ ) {
			$pages[$page_ids[$i]] = esc_html__( get_the_title( $page_ids[$i] ), 'elementary-addons' );
		}

		$obj->add_control(
			$prefix . '_dynamic_tag_page_title_is_current',
			[
				'label' => esc_html__( 'Current Page', 'elementary-addons' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Yes', 'elementary-addons' ),
				'label_off' => esc_html__( 'No', 'elementary-addons' ),
				'return_value' => 'yes',
				'default' => 'yes',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'page_title' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_page_title_page_id',
			[
				'label' => esc_html__( 'Available Pages', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => $pages,
				'default' => '',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'page_title', $prefix . '_dynamic_tag_page_title_is_current' => '' ], $condition_arr ),
			]
		);



		$obj->add_control(
			$prefix . '_dynamic_tag_date_format',
			[
				'label' => esc_html__( 'Date Format', 'elementary-addons' ),
				'type' => Controls_Manager::SELECT,
				'options' => [
					'default' => esc_html__( 'Default', 'elementary-addons' ),
					'' => esc_html__( 'None', 'elementary-addons' ),
					'F j, Y' => gmdate( 'F j, Y' ),
					'Y-m-d' => gmdate( 'Y-m-d' ),
					'm/d/Y' => gmdate( 'm/d/Y' ),
					'd/m/Y' => gmdate( 'd/m/Y' ),
					'custom' => esc_html__( 'Custom', 'elementary-addons' ),
				],
				'default' => 'default',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'current_datetime' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_time_formats',
			[
				'label' => esc_html__( 'Time Format', 'elementary-addons' ),
				'type' => Controls_Manager::SELECT,
				'options' => [
					'default' => esc_html__( 'Default', 'elementary-addons' ),
					'' => esc_html__( 'None', 'elementary-addons' ),
					'g:i a' => gmdate( 'g:i a' ),
					'g:i A' => gmdate( 'g:i A' ),
					'H:i' => gmdate( 'H:i' ),
				],
				'default' => 'default',
				'condition' => array_merge( [
					$prefix . '_dynamic_tag_date_format!' => 'custom',
					$prefix . '_dynamic_tag_type' => 'current_datetime',
				], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_custom_formats',
			[
				'label' => esc_html__( 'Custom Format', 'elementary-addons' ),
				'default' => get_option( 'date_format' ) . ' ' . get_option( 'time_format' ),
				'description' => sprintf( '<a href="https://go.elementor.com/wordpress-date-time/" target="_blank">%s</a>', esc_html__( 'Time formatting info', 'elementary-addons' ) ),
				'condition' => array_merge( [
					$prefix . '_dynamic_tag_date_format' => 'custom',
					$prefix . '_dynamic_tag_type' => 'current_datetime',
				], $condition_arr ),
			]
		);

		$obj->add_control(
      $prefix . '_dynamic_tag_request_parameter_type',
      [
        'label' => esc_html__( 'List Type', 'elementary-addons' ),
        'type' =>  Controls_Manager::SELECT,
        'options' => [
          'GET'  => esc_html__( 'GET', 'elementary-addons' ),
          'POST'  => esc_html__( 'POST', 'elementary-addons' ),
					'QUERY_VAR'  => esc_html__( 'QUERY VAR', 'elementary-addons' ),
        ],
        'default' => 'GET',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'request_parameter' ], $condition_arr ),
      ]
    );

		$obj->add_control(
			$prefix . '_dynamic_tag_request_parameter_name',
			[
				'label' => esc_html__( 'Request Parameter', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'request_parameter' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_shortcode_text',
			[
				'label' => esc_html__( 'Shortcode', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXTAREA,
				'rows' => 5,
				'placeholder' => esc_html__( 'Enter shortcode here...', 'elementary-addons' ),
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'shortcode' ], $condition_arr ),
			]
		);



		$obj->add_control(
			$prefix . '_dynamic_tag_user_info_curr_or_selected',
			[
				'label' => esc_html__( 'Current or Selected', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [
					'current' => esc_html__( 'Current', 'elementary-addons' ),
					'selected' => esc_html__( 'Selected', 'elementary-addons' ),
				],
				'default' => 'current',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'user_info' ], $condition_arr ),
			]
		);

		$user_list = [];
		$all_users = get_users();
		for ( $i = 0; $i < count( $all_users ); $i++ ) {
			$user_list[$all_users[$i]->ID] = esc_html__( $all_users[$i]->user_login, 'elementary-addons' );
		}

		$obj->add_control(
			$prefix . '_dynamic_tag_user_info_user_list',
			[
				'label' => esc_html__( 'Current or Selected', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => $user_list,
				'default' => '',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'user_info', $prefix . '_dynamic_tag_user_info_curr_or_selected' => 'selected' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_user_info_item',
			[
				'label' => esc_html__( 'User Info', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [
					'user_login' => esc_html__( 'Login', 'elementary-addons' ),
					'user_nicename' => esc_html__( 'Nice Name', 'elementary-addons' ),
					'user_email' => esc_html__( 'Email', 'elementary-addons' ),
					'user_url' => esc_html__( 'URL', 'elementary-addons' ),
					'user_registered' => esc_html__( 'Registered Time', 'elementary-addons' ),
					'display_name' => esc_html__( 'Display Name', 'elementary-addons' ),
				],
				'default' => 'user_login',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'user_info' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_site_url_is_link',
			[
				'label' => esc_html__( 'Make Link', 'elementary-addons' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Yes', 'elementary-addons' ),
				'label_off' => esc_html__( 'No', 'elementary-addons' ),
				'return_value' => 'yes',
				'default' => '',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'site_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_site_url_link_target',
			[
				'label' => esc_html__( 'Link Target', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [

					'_parent'  => esc_html__( 'New Window', 'elementary-addons' ),
					'_blank'  => esc_html__( 'The same window', 'elementary-addons' ),
				],
				'default' => '_parent',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'site_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_site_url_choose_content',
			[
				'label' => esc_html__( 'Link Content', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [

					'link'  => esc_html__( 'Link', 'elementary-addons' ),
					'custom'  => esc_html__( 'Custom', 'elementary-addons' ),
				],
				'default' => 'link',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'site_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_site_url_content',
			[
				'label' => esc_html__( 'Link Text', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXTAREA,
				'rows' => 5,
				'placeholder' => esc_html__( 'Link text...', 'elementary-addons' ),
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'site_url', $prefix . '_dynamic_tag_post_url_choose_content' => 'custom' ], $condition_arr ),
			]
		);


		$obj->add_control(
			$prefix . '_dynamic_tag_archive_meta_key',
			[
				'label' => esc_html__( 'Meta Key', 'elementary-addons' ),
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'archive_meta' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_featured_image_data_attachment_data',
			[
				'label' => esc_html__( 'Data', 'elementary-addons' ),
				'type' => Controls_Manager::SELECT,
				'default' => 'title',
				'options' => [
					'title' => esc_html__( 'Title', 'elementary-addons' ),
					'alt' => esc_html__( 'Alt', 'elementary-addons' ),
					'caption' => esc_html__( 'Caption', 'elementary-addons' ),
					'description' => esc_html__( 'Description', 'elementary-addons' ),
					'src' => esc_html__( 'File URL', 'elementary-addons' ),
					'href' => esc_html__( 'Attachment URL', 'elementary-addons' ),
				],
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'featured_image_data' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_featured_image_data_attachment_url_is_link',
			[
				'label' => esc_html__( 'Make Link', 'elementary-addons' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Yes', 'elementary-addons' ),
				'label_off' => esc_html__( 'No', 'elementary-addons' ),
				'return_value' => 'yes',
				'default' => '',
				'condition' => array_merge( [
					$prefix . '_dynamic_tag_type' => 'featured_image_data',
					$prefix . '_dynamic_tag_featured_image_data_attachment_data' => [ 'src', 'href'],

				], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_featured_image_data_attachment_url_link_target',
			[
				'label' => esc_html__( 'Link Target', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [
					'_parent'  => esc_html__( 'New Window', 'elementary-addons' ),
					'_blank'  => esc_html__( 'The same window', 'elementary-addons' ),
				],
				'default' => '_parent',
				'condition' => array_merge( [
					$prefix . '_dynamic_tag_type' => 'featured_image_data',
					$prefix . '_dynamic_tag_featured_image_data_attachment_data' => [ 'src', 'href'],

				], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_featured_image_data_attachment_url_choose_content',
			[
				'label' => esc_html__( 'Link Content', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [

					'link'  => esc_html__( 'Link', 'elementary-addons' ),
					'custom'  => esc_html__( 'Custom', 'elementary-addons' ),
				],
				'default' => 'link',
				'condition' => array_merge( [
					$prefix . '_dynamic_tag_type' => 'featured_image_data',
					$prefix . '_dynamic_tag_featured_image_data_attachment_data' => [ 'src', 'href'],
				], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_featured_image_data_attachment_url_content',
			[
				'label' => esc_html__( 'Link Text', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXTAREA,
				'rows' => 5,
				'placeholder' => esc_html__( 'Link text...', 'elementary-addons' ),
				'condition' => array_merge( [
					$prefix . '_dynamic_tag_type' => 'featured_image_data',
					$prefix . '_dynamic_tag_featured_image_data_attachment_data' => [ 'src', 'href'],
					$prefix . '_dynamic_tag_post_url_choose_content' => 'custom'
				],  $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_author_info_item',
			[
				'label' => esc_html__( 'User Info', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [
					'ID' => esc_html__( 'ID', 'elementary-addons' ),
					'user_login' => esc_html__( 'Author Login', 'elementary-addons' ),
					'first_name' => esc_html__( 'Author First Name', 'elementary-addons' ),
					'last_name' => esc_html__( 'Author Last Name', 'elementary-addons' ),
					'display_name' => esc_html__( 'Author Display Name', 'elementary-addons' ),
					'nickname' => esc_html__( 'Author Nickname', 'elementary-addons' ),
					'description' => esc_html__( 'Author Description', 'elementary-addons' ),
					'user_level' => esc_html__( 'Author User Level', 'elementary-addons' ),
					// 'user_url' => esc_html__( 'Author URL', 'elementary-addons' ),
					'author_avatar' => esc_html__( 'Author Avatar', 'elementary-addons' ),
				],
				'default' => 'user_login',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'author_info' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_author_meta_key',
			[
				'label' => esc_html__( 'Author Meta Key', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [
					'admin_color' => esc_html__( 'Admin Color', 'elementary-addons' ),
					'aim' => esc_html__( 'AIM', 'elementary-addons' ),
					'comment_shortcuts' => esc_html__( 'Comment Shortcuts', 'elementary-addons' ),
					'description' => esc_html__( 'Description', 'elementary-addons' ),
					'display_name' => esc_html__( 'Display Name', 'elementary-addons' ),
					'first_name' => esc_html__( 'First Name', 'elementary-addons' ),
					'ID' => esc_html__( 'ID', 'elementary-addons' ),
					'jabber' => esc_html__( 'Jabber', 'elementary-addons' ),
					'last_name' => esc_html__( 'Last Name', 'elementary-addons' ),
					'nickname' => esc_html__( 'Nickname', 'elementary-addons' ),
					'plugins_last_view' => esc_html__( 'Plugins Last View', 'elementary-addons' ),
					'plugins_per_page' => esc_html__( 'Plugins Per Page', 'elementary-addons' ),
					'rich_editing' => esc_html__( 'Rich Text Editing', 'elementary-addons' ),
					'syntax_highlighting' => esc_html__( 'Syntax Highlighting', 'elementary-addons' ),
					'user_activation_key' => esc_html__( 'Activation Key', 'elementary-addons' ),
					'user_description' => esc_html__( 'Description', 'elementary-addons' ),
					'user_email' => esc_html__( 'Email', 'elementary-addons' ),
					'user_firstname' => esc_html__( 'First Name', 'elementary-addons' ),
					'user_lastname' => esc_html__( 'Last Name', 'elementary-addons' ),
					'user_level' => esc_html__( 'User Level', 'elementary-addons' ),
					'user_login' => esc_html__( 'Login', 'elementary-addons' ),
					'user_nicename' => esc_html__( 'Nice Name', 'elementary-addons' ),
					'user_registered' => esc_html__( 'Registered', 'elementary-addons' ),
					'user_status' => esc_html__( 'Status', 'elementary-addons' ),
					// 'user_url' => esc_html__( 'URL', 'elementary-addons' ),
					'yim' => esc_html__( 'YIM', 'elementary-addons' ),
				],
				'default' => 'user_login',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'author_meta' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_author_url',
			[
				'label' => esc_html__( 'URL', 'elementary-addons' ),
				'type' => Controls_Manager::SELECT,
				'default' => 'website',
				'options' => [
					'archive' => esc_html__( 'Author Archive', 'elementary-addons' ),
					'website' => esc_html__( 'Author Website', 'elementary-addons' ),
				],
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'author_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_author_url_is_link',
			[
				'label' => esc_html__( 'Make Link', 'elementary-addons' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Yes', 'elementary-addons' ),
				'label_off' => esc_html__( 'No', 'elementary-addons' ),
				'return_value' => 'yes',
				'default' => '',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'author_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_author_url_link_target',
			[
				'label' => esc_html__( 'Link Target', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [

					'_parent'  => esc_html__( 'New Window', 'elementary-addons' ),
					'_blank'  => esc_html__( 'The same window', 'elementary-addons' ),
				],
				'default' => '_parent',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'author_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_author_url_choose_content',
			[
				'label' => esc_html__( 'Link Content', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [

					'link'  => esc_html__( 'Link', 'elementary-addons' ),
					'custom'  => esc_html__( 'Custom', 'elementary-addons' ),
				],
				'default' => 'link',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'author_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_author_url_content',
			[
				'label' => esc_html__( 'Link Text', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXTAREA,
				'rows' => 5,
				'placeholder' => esc_html__( 'Link text...', 'elementary-addons' ),
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'author_url', $prefix . '_dynamic_tag_author_url_choose_content' => 'custom' ], $condition_arr ),
			]
		);


		$obj->add_control(
			$prefix . '_dynamic_tag_comments_url_is_link',
			[
				'label' => esc_html__( 'Make Link', 'elementary-addons' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Yes', 'elementary-addons' ),
				'label_off' => esc_html__( 'No', 'elementary-addons' ),
				'return_value' => 'yes',
				'default' => '',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'comments_url' ], $condition_arr ),
			]
		);


		$obj->add_control(
			$prefix . '_dynamic_tag_comments_url_link_target',
			[
				'label' => esc_html__( 'Link Target', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [

					'_parent'  => esc_html__( 'New Window', 'elementary-addons' ),
					'_blank'  => esc_html__( 'The same window', 'elementary-addons' ),
				],
				'default' => '_parent',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'comments_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_comments_url_choose_content',
			[
				'label' => esc_html__( 'Link Content', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [

					'link'  => esc_html__( 'Link', 'elementary-addons' ),
					'custom'  => esc_html__( 'Custom', 'elementary-addons' ),
				],
				'default' => 'link',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'comments_url' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_tag_comments_url_content',
			[
				'label' => esc_html__( 'Link Text', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXTAREA,
				'rows' => 5,
				'placeholder' => esc_html__( 'Link text...', 'elementary-addons' ),
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'comments_url', $prefix . '_dynamic_tag_comments_url_choose_content' => 'custom' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_wc_product_price_type',
			[
				'label' => esc_html__( 'List Type', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [
					'regular_price'  => esc_html__( 'Regular Price', 'elementary-addons' ),
					'sale_price'  => esc_html__( 'Sale Price', 'elementary-addons' ),
					'price'  => esc_html__( 'Price', 'elementary-addons' ),
				],
				'default' => 'price',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'woocommerce_product_price' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_wc_product_price_min_max',
			[
				'label' => esc_html__( 'Min/Max Variable Product Price', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [
					'min'  => esc_html__( 'Minimum', 'elementary-addons' ),
					'max'  => esc_html__( 'Maximum', 'elementary-addons' ),
				],
				'default' => 'min',
				'condition' => array_merge( [
					$prefix . '_dynamic_tag_type' => 'woocommerce_product_price',
					$prefix . '_dynamic_wc_product_price_type' => [ 'regular_price', 'sale_price', 'price' ],

				], $condition_arr ),
			]
		);


		$obj->add_control(
			$prefix . '_dynamic_wc_product_rating_type',
			[
				'label' => esc_html__( 'Rating Type', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [
					'wc_html'  => esc_html__( 'WC Stars', 'elementary-addons' ),
					'raw'  => esc_html__( 'Raw', 'elementary-addons' ),
				],
				'default' => 'wc_html',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'woocommerce_product_rating' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_wc_product_rating_star_type',
			[
				'label' => esc_html__( 'Star Type', 'elementary-addons' ),
				'type' =>  Controls_Manager::SELECT,
				'options' => [
					'&#10026;'  => esc_html__( 'Star 1', 'elementary-addons' ),
					'&#10027;'  => esc_html__( 'Star 2', 'elementary-addons' ),
					'&#10028;'  => esc_html__( 'Star 3', 'elementary-addons' ),
					'&#10029;'  => esc_html__( 'Star 4', 'elementary-addons' ),
					'&#10030;'  => esc_html__( 'Star 5', 'elementary-addons' ),
					'&#10031;'  => esc_html__( 'Star 6', 'elementary-addons' ),
				],
				'default' => '&#10026;',
				'condition' => array_merge( [
					$prefix . '_dynamic_tag_type' => 'woocommerce_product_rating',
					$prefix . '_dynamic_wc_product_rating_type' => 'wc_html',
				], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_wc_product_sale_id',
			[
				'label' => esc_html__( 'Product ID', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'woocommerce_product_sale' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_wc_product_sale_text',
			[
				'label' => esc_html__( 'Sale text', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXTAREA,
				'rows' => 5,
				'placeholder' => esc_html__( 'Sale text...', 'elementary-addons' ),
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'woocommerce_product_sale' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_wc_product_short_desc_id',
			[
				'label' => esc_html__( 'Product ID', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'woocommerce_product_short_description' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_wc_product_sku_id',
			[
				'label' => esc_html__( 'Product ID', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'woocommerce_product_sku' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_wc_product_stock_id',
			[
				'label' => esc_html__( 'Product ID', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'woocommerce_product_stock' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_wc_product_stock_html',
			[
				'label' => esc_html__( 'Stock HTML', 'elementary-addons' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Yes', 'elementary-addons' ),
				'label_off' => esc_html__( 'No', 'elementary-addons' ),
				'return_value' => 'yes',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'woocommerce_product_stock' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_wc_product_terms_id',
			[
				'label' => esc_html__( 'Product ID', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'woocommerce_product_terms' ], $condition_arr ),
			]
		);

		$tax_options = [];
		$tax_args = [
			'show_in_nav_menus' => true,
			'object_type' => [ 'product' ],
		];
		$taxs = get_taxonomies( $tax_args, 'objects' );
		foreach ( $taxs as $key => $val ) {
			$tax_options[ $key ] = $val->label;
		}

		$obj->add_control(
			$prefix . '_dynamic_wc_product_terms_taxonomy',
			[
				'label' => esc_html__( 'Product Taxonomy', 'elementary-addons' ),
				'type' => Controls_Manager::SELECT,
				'options' => $tax_options,
				'default' => 'product_cat',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'woocommerce_product_terms' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_wc_product_terms_separator',
			[
				'label' => esc_html__( 'Taxonomy Separator', 'elementary-addons' ),
				'type' => Controls_Manager::TEXT,
				'default' => ', ',
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'woocommerce_product_terms' ], $condition_arr ),
			]
		);

		$obj->add_control(
			$prefix . '_dynamic_wc_product_title_id',
			[
				'label' => esc_html__( 'Product ID', 'elementary-addons' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'condition' => array_merge( [ $prefix . '_dynamic_tag_type' => 'woocommerce_product_title' ], $condition_arr ),
			]
		);

		///////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////

		if ( $before_after_type === 'text' ) {
			$obj->start_controls_tabs( $prefix . '_dynamic_tag_wysiwygs' );

			$obj->start_controls_tab(
				$prefix . '_dynamic_tag_text_bef',
				[
					'label' => esc_html__( 'Before Text', 'elementary-addons' ),
				]
			);

			$obj->add_control(
				$prefix . '_dynamic_tag_text_before',
				[
					'label' => esc_html__( 'Before Text', 'elementary-addons' ),
					'type' => \Elementor\Controls_Manager::TEXTAREA,
					'placeholder' => esc_html__( 'Before text...', 'elementary-addons' ),
					'condition' => $condition_arr,
				]
			);

			$obj->end_controls_tab();

			$obj->start_controls_tab(
				$prefix . '_dynamic_tag_text_aft',
				[
					'label' => esc_html__( 'After Text', 'elementary-addons' ),
				]
			);

			$obj->add_control(
				$prefix . '_dynamic_tag_text_after',
				[
					'label' => esc_html__( 'After Text', 'elementary-addons' ),
					'type' => \Elementor\Controls_Manager::TEXTAREA,
					'placeholder' => esc_html__( 'After text...', 'elementary-addons' ),
					'condition' => $condition_arr,
				]
			);

			$obj->end_controls_tab();
			$obj->end_controls_tabs();
		}
		elseif ( $before_after_type === 'wysiwyg' ) {

			$obj->start_controls_tabs( $prefix . '_dynamic_tag_wysiwygs' );

			$obj->start_controls_tab(
				$prefix . '_dynamic_tag_wysiwyg_bef',
				[
					'label' => esc_html__( 'Before Text', 'elementary-addons' ),
				]
			);

			$obj->add_control(
				$prefix . '_dynamic_tag_wysiwyg_before',
				[
					'label' => esc_html__( 'Before Text', 'elementary-addons' ),
					'type' => \Elementor\Controls_Manager::WYSIWYG,
					'placeholder' => esc_html__( 'Before text...', 'elementary-addons' ),
					'condition' => $condition_arr,
				]
			);

			$obj->end_controls_tab();

			$obj->start_controls_tab(
				$prefix . '_dynamic_tag_wysiwyg_aft',
				[
					'label' => esc_html__( 'After Text', 'elementary-addons' ),
				]
			);

			$obj->add_control(
				$prefix . '_dynamic_tag_wysiwyg_after',
				[
					'label' => esc_html__( 'After Text', 'elementary-addons' ),
					'type' => \Elementor\Controls_Manager::WYSIWYG,
					'placeholder' => esc_html__( 'After text...', 'elementary-addons' ),
					'condition' => $condition_arr,
				]
			);
		}

		$obj->end_controls_tab();
		$obj->end_controls_tabs();

	} //end controls section


	public function get_dynamic_tag( $settings, $current_item, $prefix, $before_after_type ){

		switch ( $current_item[$prefix . '_dynamic_tag_type'] ) {

			case 'post_custom_field':
			$def_id = intval( $current_item[$prefix . '_dynamic_tag_custom_field_post_id'] );
			$post = get_post();
			$post_id = ( isset( $def_id ) && $def_id !== '' ) ? $def_id : $post->ID;
			$field = get_post_custom_values( $current_item[$prefix . '_dynamic_tag_custom_field_name'], $post_id );
			$dynamic_tag = $field[0];
			break;

			case 'post_id':
			$post = get_post();
			$dynamic_tag = $post->ID;
			break;

			case 'post_terms':
			$taxonomy = $current_item[$prefix . '_dynamic_tag_post_terms_taxonomy'];
			// $terms = intval( $current_item[$prefix . '_dynamic_tag_post_terms_terms'] );
			$separator = $current_item[$prefix . '_dynamic_tag_post_terms_separator'];
			$def_id = intval( $current_item[$prefix . '_dynamic_tag_post_terms_post_id'] );
			$post = get_post();
			$post_id = ( isset( $def_id ) && $def_id !== '' ) ? $def_id : $post->ID;
			if ( 'yes' === $current_item[$prefix . '_dynamic_tag_post_terms_link'] ) {
				$value = get_the_term_list( $post_id, $taxonomy, '', $separator );
			} else {
				$terms = get_the_terms( $post_id, $taxonomy );
				if ( is_wp_error( $terms ) || empty( $terms ) ) {
					return '';
				}
				$term_names = [];
				foreach ( $terms as $term ) {
					$term_names[] = '<span>' . $term->name . '</span>';
				}
				$value = implode( $separator, $term_names );
			}
			$dynamic_tag = $value;
			break;

			case 'post_time':
			$def_id = intval( $current_item[$prefix . '_dynamic_tag_post_time_post_id'] );
			$post = get_post();
			$post_id = ( isset( $def_id ) && $def_id !== '' ) ? $def_id : $post->ID;
			if( $current_item[$prefix . '_dynamic_tag_post_time_type'] === 'post_date' ){
				$dynamic_tag = get_the_date( '', $post_id );
			}
			if( $current_item[$prefix . '_dynamic_tag_post_time_type'] === 'post_modified' ){
				$mod_date = get_the_modified_date( '', $post_id );
				$dynamic_tag = ( $mod_date !== '' ) ? $mod_date : get_the_date( '', $post_id );
			}
			break;

			case 'post_title':
			$def_id = intval( $current_item[$prefix . '_dynamic_tag_post_title_post_id'] );
			$post = get_post();
			$post_id = ( isset( $def_id ) && $def_id !== '' ) ? $def_id : $post->ID;
			$dynamic_tag = get_the_title( $post_id );
			break;

			case 'post_url':
			$def_id = intval( $current_item[$prefix . '_dynamic_tag_post_url_post_id'] );
			$post = get_post();
			$post_id = ( isset( $def_id ) && $def_id !== '' ) ? $def_id : $post->ID;
			$is_link = $current_item[$prefix . '_dynamic_tag_post_url_is_link'];
			$target = $current_item[$prefix . '_dynamic_tag_post_url_link_target'];
			$choose_content = $current_item[$prefix . '_dynamic_tag_post_url_choose_content'];
			$pre = ( $is_link === 'yes' ) ? '<a href="' . get_permalink( $post_id ) . '" target="' . $target . '">' : '';
			$content = ( $choose_content === 'link' ) ? get_permalink( $post_id ) : $current_item[$prefix . '_dynamic_tag_post_url_content'];
			$after = ( $is_link === 'yes' ) ? '</a>' : '';
			$dynamic_tag = $pre . $content . $after;
			break;

			case 'post_category':
			$def_id = intval( $current_item[$prefix . '_dynamic_tag_post_category_post_id'] );
			$post = get_post();
			$post_id = ( isset( $def_id ) && $def_id !== '' ) ? $def_id : $post->ID;
			$cat_obj = get_the_category( $post_id );
			$dynamic_tag = '';
			for ( $cat = 0; $cat < count( $cat_obj ); $cat++ ) {
				$dynamic_tag .= $cat_obj[$cat]->name;
				if( $cat < count( $cat_obj ) - 1 ){
					$dynamic_tag .= ', ';
				}
			}
			// var_dump( $cat_obj );
			break;

			case 'archive_description':
			$dynamic_tag = get_the_archive_description();
			break;

			case 'archive_meta':
			$key = $current_item[$prefix . '_dynamic_tag_archive_meta_key'];
			if ( empty( $key ) ) {
				return;
			}
			$value = '';
			if ( is_category() || is_tax() ) {
				$value = get_term_meta( get_queried_object_id(), $key, true );
			}
			elseif ( is_author() ) {
				$value = get_user_meta( get_queried_object_id(), $key, true );
			}
			$dynamic_tag = $value;
			break;

			case 'archive_title':
			$dynamic_tag = get_the_archive_title();
			break;

			case 'archive_url':
			$post_type = $current_item[$prefix . '_dynamic_tag_archive_url_post_type'];
			$is_link = $current_item[$prefix . '_dynamic_tag_archive_url_is_link'];
			$target = $current_item[$prefix . '_dynamic_tag_archive_url_link_target'];
			$choose_content = $current_item[$prefix . '_dynamic_tag_archive_url_choose_content'];
			$pre = ( $is_link === 'yes' ) ? '<a href="' . get_post_type_archive_link( $post_type ) . '" target="' . $target . '">' : '';
			$content = ( $choose_content === 'link' ) ? get_post_type_archive_link( $post_type ) : $current_item[$prefix . '_dynamic_tag_archive_url_content'];
			$after = ( $is_link === 'yes' ) ? '</a>' : '';
			$dynamic_tag = $pre . $content . $after;
			break;

			case 'page_title':
			$is_curr_page = $current_item[$prefix . '_dynamic_tag_page_title_is_current'];
			$id = ( $is_curr_page !== 'yes' ) ? intval( $current_item[$prefix . '_dynamic_tag_page_title_page_id'] ) : '';
			$dynamic_tag = get_the_title( $id );
			break;

			case 'site_title':
			$dynamic_tag = get_bloginfo();
			break;

			case 'site_tagline':
			$dynamic_tag = get_bloginfo( 'description' );
			break;

			case 'current_datetime':
			if ( 'custom' === $current_item[$prefix . '_dynamic_tag_date_format'] ) {
				$format = $current_item[$prefix . '_dynamic_tag_custom_formats'];
			}
			else{
				$date_format = $current_item[$prefix . '_dynamic_tag_date_format'];
				$time_format = $current_item[$prefix . '_dynamic_tag_time_formats'];
				$format = '';

				if ( 'default' === $date_format ) {
					$date_format = get_option( 'date_format' );
				}

				if ( 'default' === $time_format ) {
					$time_format = get_option( 'time_format' );
				}

				if ( $date_format ) {
					$format = $date_format;
					$has_date = true;
				} else {
					$has_date = false;
				}

				if ( $time_format ) {
					if ( $has_date ) {
						$format .= ' ';
					}
					$format .= $time_format;
				}
			}

			$value = date_i18n( $format );

			$dynamic_tag = $value;
			break;

			case 'request_parameter':
			$req_type = isset( $current_item[$prefix . '_dynamic_tag_request_parameter_type'] ) ? $current_item[$prefix . '_dynamic_tag_request_parameter_type'] : false;
			$param_name = isset( $current_item[$prefix . '_dynamic_tag_request_parameter_name'] ) ? $current_item[$prefix . '_dynamic_tag_request_parameter_name'] : false;
			$value = '';
			switch ( $req_type ) {
				case 'POST':
					if ( ! isset( $_POST[ $param_name ] ) ) {
						return '';
					}
					$value = sanitize_text_field( $_POST[ $param_name ] );
					break;
				case 'GET':
					if ( ! isset( $_GET[ $param_name ] ) ) {
						return '';
					}
					$value = sanitize_text_field( $_GET[ $param_name ] );
					break;
				case 'QUERY_VAR':
					$value = get_query_var( $param_name );
					break;
			}
			$dynamic_tag = $value;
			break;

			case 'shortcode':
			$shortcode = $current_item[$prefix . '_dynamic_tag_shortcode_text'];
			$dynamic_tag = do_shortcode( $shortcode );
			break;

			case 'user_info':
			$curr_or_selected = $current_item[$prefix . '_dynamic_tag_user_info_curr_or_selected'];
			$user_info = $current_item[$prefix . '_dynamic_tag_user_info_item'];
			$selected_user = $current_item[$prefix . '_dynamic_tag_user_info_user_list'];
			if( $curr_or_selected === 'current' ){
				$curr_u_data = wp_get_current_user();
				$dynamic_tag = $curr_u_data->{$user_info};
			}
			elseif( $curr_or_selected === 'selected' ){
				$u_data = get_userdata( $selected_user );
				$dynamic_tag = $u_data->{$user_info};
			}
			else{
				$dynamic_tag = esc_html__( 'No data...', 'elementary-addons' );
			}
			break;

			case 'site_url':
			$is_link = $current_item[$prefix . '_dynamic_tag_site_url_is_link'];
			$target = $current_item[$prefix . '_dynamic_tag_site_url_link_target'];
			$choose_content = $current_item[$prefix . '_dynamic_tag_site_url_choose_content'];
			$pre = ( $is_link === 'yes' ) ? '<a href="' . site_url( $post_id ) . '" target="' . $target . '">' : '';
			$content = ( $choose_content === 'link' ) ? site_url( $post_id ) : $current_item[$prefix . '_dynamic_tag_site_url_content'];
			$after = ( $is_link === 'yes' ) ? '</a>' : '';
			$dynamic_tag = $pre . $content . $after;
			break;

			case 'internal_url':
			$dynamic_tag = 'work in progress...';
			break;

			case 'featured_image_data':

			$th_id = get_post_thumbnail_id();
			if ( ! $th_id ) {
				return false;
			}
			$attachment = get_post( $th_id );
			if ( ! $attachment ) {
				return;
			}
			$value = '';
			$is_link = $current_item[$prefix . '_dynamic_tag_featured_image_data_attachment_url_is_link'];
			$target = $current_item[$prefix . '_dynamic_tag_featured_image_data_attachment_url_link_target'];
			$choose_content = $current_item[$prefix . '_dynamic_tag_featured_image_data_attachment_url_choose_content'];
			switch ( $current_item[$prefix . '_dynamic_tag_featured_image_data_attachment_data'] ) {
				case 'alt':
				$value = get_post_meta( $attachment->ID, '_wp_attachment_image_alt', true );
				break;
				case 'caption':
				$value = $attachment->post_excerpt;
				break;
				case 'description':
				$value = $attachment->post_content;
				break;
				case 'href':
				$pre = ( $is_link === 'yes' ) ? '<a href="' . get_permalink( $attachment->ID ) . '" target="' . $target . '">' : '';
				$content = ( $choose_content === 'link' ) ? get_permalink( $attachment->ID ) : $current_item[$prefix . '_dynamic_tag_featured_image_data_attachment_url_content'];
				$after = ( $is_link === 'yes' ) ? '</a>' : '';
				$value = $pre . $content . $after;
				break;
				case 'src':
				$pre = ( $is_link === 'yes' ) ? '<a href="' . $attachment->guid . '" target="' . $target . '">' : '';
				$content = ( $choose_content === 'link' ) ? $attachment->guid : $current_item[$prefix . '_dynamic_tag_featured_image_data_attachment_url_content'];
				$after = ( $is_link === 'yes' ) ? '</a>' : '';
				$value = $pre . $content . $after;
				break;
				case 'title':
				$value = $attachment->post_title;
				break;
			}
			$dynamic_tag = $value;
			break;

			case 'author_info':
			$author_info = $current_item[$prefix . '_dynamic_tag_author_info_item'];
			$author_options = array(
				'ID', 'user_login', 'first_name', 'last_name', 'display_name',
				'nickname', 'description', 'user_level', 'user_url'
			);
			if( in_array( $author_info, $author_options ) ){
				$dynamic_tag = get_the_author_meta( $author_info );
			}
			elseif( 'author_avatar' === $author_info ){
				$dynamic_tag = get_avatar( get_the_author_meta( 'ID' ), 96 );
			}
			break;

			case 'author_meta':
			$key = $current_item[$prefix . '_dynamic_tag_author_meta_key'];
			if ( empty( $key ) ) {
				return;
			}
			$value = get_the_author_meta( $key );
			$dynamic_tag = $value;
			break;

			case 'author_name':
			$dynamic_tag = get_the_author();
			break;

			case 'author_url':
			$is_link = $current_item[$prefix . '_dynamic_tag_author_url_is_link'];
			$target = $current_item[$prefix . '_dynamic_tag_author_url_link_target'];
			$choose_content = $current_item[$prefix . '_dynamic_tag_author_url_choose_content'];
			$value = '';
			if ( 'archive' === $current_item[$prefix . '_dynamic_tag_author_url'] ) {
				global $authordata;
				if ( $authordata ) {
					$pre = ( $is_link === 'yes' ) ? '<a href="' . get_author_posts_url( $authordata->ID, $authordata->user_nicename ) . '" target="' . $target . '">' : '';
					$content = ( $choose_content === 'link' ) ? get_author_posts_url( $authordata->ID, $authordata->user_nicename ) : $current_item[$prefix . '_dynamic_tag_author_url_content'];
				}
			} else {
				$value = get_the_author_meta( 'url' );
				$pre = ( $is_link === 'yes' ) ? '<a href="' . get_the_author_meta( 'url' ) . '" target="' . $target . '">' : '';
				$content = ( $choose_content === 'link' ) ? get_the_author_meta( 'url' ) : $current_item[$prefix . '_dynamic_tag_author_url_content'];
			}
			$after = ( $is_link === 'yes' ) ? '</a>' : '';
			$dynamic_tag = $pre . $content . $after;
			break;

			case 'comments_number':
			$post = get_post();
			$post_id = $post->ID;
			$dynamic_tag = get_comments_number( intval( $post_id ) );
			break;

			case 'comments_url':
			$post = get_post();
			$id = $post->ID;
			$is_link = $current_item[$prefix . '_dynamic_tag_comments_url_is_link'];
			$target = $current_item[$prefix . '_dynamic_tag_comments_url_link_target'];
			$choose_content = $current_item[$prefix . '_dynamic_tag_comments_url_choose_content'];
			$pre = ( $is_link === 'yes' ) ? '<a href="' . get_comments_link( $post_id ) . '" target="' . $target . '">' : '';
			$content = ( $choose_content === 'link' ) ? get_comments_link( $post_id ) : $current_item[$prefix . '_dynamic_tag_comments_url_content'];
			$after = ( $is_link === 'yes' ) ? '</a>' : '';
			$dynamic_tag = $pre . $content . $after;
			break;

			case 'woocommerce_product_price':
			$wc_price_type = $current_item[$prefix . '_dynamic_wc_product_price_type'];
			$min_max = $current_item[$prefix . '_dynamic_wc_product_price_min_max'];
			$post = get_post();
			$product_id = $post->ID;
			$wc_product = wc_get_product( $product_id );
			global $product;
			if( $wc_price_type === 'regular_price' ){
				if ( $product->is_type( 'variable' ) ) {
					if( $min_max === 'min' ){
						$dynamic_tag = $product->get_variation_regular_price( 'min' );
					}
					elseif( $min_max === 'max' ){
						$dynamic_tag = $product->get_variation_regular_price( 'max' );
					}
				}
				else{
					$dynamic_tag = $wc_product->get_regular_price();
				}
				$dynamic_tag .= ' ' . get_woocommerce_currency_symbol();
			}
			elseif( $wc_price_type === 'sale_price' ){
				if ( $product->is_type( 'variable' ) ) {
					if( $min_max === 'min' ){
						$dynamic_tag = $product->get_variation_sale_price( 'min' );
					}
					elseif( $min_max === 'max' ){
						$dynamic_tag = $product->get_variation_sale_price( 'max' );
					}
				}
				else{
					$dynamic_tag = $wc_product->get_sale_price();
				}
				$dynamic_tag .= ' ' . get_woocommerce_currency_symbol();
			}
			elseif( $wc_price_type === 'price' ){
				$dyn_tag = $product->get_price_html();
				$dyn_tag2 = str_replace( '–', '', $dyn_tag );
				$dynamic_tag = $dyn_tag2;
			}
			break;

			case 'woocommerce_product_rating':
			$wc_price_type = $current_item[$prefix . '_dynamic_wc_product_rating_type'];
			$post = get_post();
			$product_id = $post->ID;
			$wc_product = wc_get_product( $product_id );
			if( $wc_price_type === 'wc_html' ){
				$rating  = $wc_product->get_average_rating();
				$count   = $wc_product->get_rating_count();
				$dynamic_tag = $this->get_star_rating( $rating, $count, $current_item[$prefix . '_dynamic_wc_product_rating_star_type'] );
			}
			elseif( $wc_price_type === 'raw' ){
				$dynamic_tag = $wc_product->get_average_rating();
			}
			break;

			case 'woocommerce_product_sale':
			$id_input = $current_item[$prefix . '_dynamic_wc_product_sale_id'];
			$post = get_post();
			$post_id = $post->ID;
			$ID = ( isset( $id_input ) && $id_input !== '' ) ? $id_input : $post_id;
			$prod = wc_get_product( $ID );
			if ( ! $prod ) {
				return;
			}
			$val = '';
			if ( $prod->is_on_sale() ) {
				$val = $current_item[$prefix . '_dynamic_wc_product_sale_text'];
			}
			$dynamic_tag = wp_kses_post( $val );
			break;

			case 'woocommerce_product_short_description':
			$id_input = $current_item[$prefix . '_dynamic_wc_product_short_desc_id'];
			$post = get_post();
			$post_id = $post->ID;
			$ID = ( isset( $id_input ) && $id_input !== '' ) ? $id_input : $post_id;
			$prod = wc_get_product( $ID );
			if ( ! $prod ) {
				return;
			}
			$dynamic_tag = $prod->get_short_description();
			break;

			case 'woocommerce_product_sku':
			$id_input = $current_item[$prefix . '_dynamic_wc_product_sku_id'];
			$post = get_post();
			$post_id = $post->ID;
			$ID = ( isset( $id_input ) && $id_input !== '' ) ? $id_input : $post_id;
			$prod = wc_get_product( $ID );
			if ( ! $prod ) {
				return;
			}
			if ( $prod->get_sku() ) {
				$dynamic_tag = $prod->get_sku();
			}
			break;


			case 'woocommerce_product_stock':
			$id_input = $current_item[$prefix . '_dynamic_wc_product_stock_id'];
			$post = get_post();
			$post_id = $post->ID;
			$ID = ( isset( $id_input ) && $id_input !== '' ) ? $id_input : $post_id;
			$prod = wc_get_product( $ID );
			if ( ! $prod ) {
				return;
			}
			if ( 'yes' === $current_item[$prefix . '_dynamic_wc_product_stock_html'] ) {
				$dynamic_tag = wc_get_stock_html( $prod );
			} else {
				$dynamic_tag = (int) $prod->get_stock_quantity();
			}
			break;

			case 'woocommerce_product_terms':
			$id_input = $current_item[$prefix . '_dynamic_wc_product_terms_id'];
			$post = get_post();
			$post_id = $post->ID;
			$ID = ( isset( $id_input ) && $id_input !== '' ) ? $id_input : $post_id;
			$prod = wc_get_product( $ID );
			if ( ! $prod ) {
				return;
			}
			$dynamic_tag = get_the_term_list( $prod->get_id(), $current_item[$prefix . '_dynamic_wc_product_terms_taxonomy'], '', $current_item[$prefix . '_dynamic_wc_product_terms_separator'] );
			break;

			case 'woocommerce_product_title':
			$id_input = $current_item[$prefix . '_dynamic_wc_product_title_id'];
			$post = get_post();
			$post_id = $post->ID;
			$ID = ( isset( $id_input ) && $id_input !== '' ) ? $id_input : $post_id;
			$prod = wc_get_product( $ID );
			if ( ! $prod ) {
				return;
			}
			$dynamic_tag = $prod->get_title();
			break;

			default:
			$dynamic_tag = esc_html__( 'Nothing...', 'elementary-addons' );
			break;

		}
		if ( $before_after_type === 'text' ){
			$before = $current_item[$prefix . '_dynamic_tag_text_before'];
			$after = $current_item[$prefix . '_dynamic_tag_text_after'];
		}
		if ( $before_after_type === 'wysiwyg' ){
			$before = $current_item[$prefix . '_dynamic_tag_wysiwyg_before'];
			$after = $current_item[$prefix . '_dynamic_tag_wysiwyg_after'];
		}

		$final_tag = $before . $dynamic_tag . $after;
		return $final_tag;
	}

	public function get_star_rating( $rating, $count, $star_type ) {

		global $woocommerce, $product;

		$average      = $rating;
		$review_count = $count;
		$percent = ( ( $average / 5 ) * 100 ) . '%';
		return '<span class="star-rating" role="img" aria-label="' . esc_html__( 'Rated' . $average . 'out of 5', 'elementary-addons' ) . '" style="clip-path: polygon(0 0,' . $percent . ' 0, ' . $percent . ' 100%,0 100%);">
		' . $star_type . $star_type . $star_type . $star_type . $star_type . '
		</span>';

	}

	public function get_taxonomies_for_dyntag( $args = [], $output = 'names', $operator = 'and' ) {
		global $wp_taxonomies;

		$field = ( 'names' === $output ) ? 'name' : false;

		// Handle 'object_type' separately.
		if ( isset( $args['object_type'] ) ) {
			$object_type = (array) $args['object_type'];
			unset( $args['object_type'] );
		}

		$taxonomies = wp_filter_object_list( $wp_taxonomies, $args, $operator );

		if ( isset( $object_type ) ) {
			foreach ( $taxonomies as $tax => $tax_data ) {
				if ( ! array_intersect( $object_type, $tax_data->object_type ) ) {
					unset( $taxonomies[ $tax ] );
				}
			}
		}

		if ( $field ) {
			$taxonomies = wp_list_pluck( $taxonomies, $field );
		}

		return $taxonomies;
	}

} // class EAFREE_Dynamic_Tag
