<?php


use Elementor\Repeater;
use Elementor\Utils;
use Elementor\Core\Base\Module;
use Elementor\Core\Breakpoints\Manager;
use Elementor\Core\Breakpoints;
use Elementor\Controls_Manager;
use Elementor\Control_Media;
use Elementor\Controls_Stack;
use Elementor\Element_Base;
use Elementor\Core\Kits\Documents\Tabs\Settings_Layout;
use Elementor\Core\Responsive\Files\Frontend;
use Elementor\Plugin;
use Elementor\Core\Responsive\Responsive;
use Elementor\Core\Files\CSS\Post;

defined('ABSPATH') or die();

class EAFREE_Section_Clip_Path{

	public function __construct() {
		add_action( 'elementor/element/section/section_background/after_section_end', array( $this, 'clip_path_controls' ), 10);
    add_action( 'elementor/frontend/section/before_render', array( $this, 'clip_path_before_render' ), 10, 1);
    add_action( 'elementor/section/print_template',  array( $this, 'clip_path_print_template'  ), 10, 2 );
	}

	public function wave_controls( $ext, $slug ){
		$ext->add_control(
      'clip_path_top_on_' . $slug,
      [
        'label' => esc_html__( 'Apply Clip Path Top', 'elementary-addons' ),
        'type' => Controls_Manager::SWITCHER,
        'label_on' => esc_html__( 'Yes', 'elementary-addons' ),
        'label_off' => esc_html__( 'No', 'elementary-addons' ),
        'return_value' => 'yes',
				'default' => '',
      ]
    );

		$ext->add_control(
      'clip_path_offset_' . $slug,
      [
        'label'   => esc_html__( 'Offset', 'elementary-addons' ),
        'type'    => Controls_Manager::NUMBER,
        'default' => 10,
        // 'selectors' => [
        //   '{{WRAPPER}} ul' => 'grid-template-columns:repeat(auto-fit, minmax({{VALUE}}px, 1fr));',
        // ],
				'condition' => [ 'clip_path_top_on_' . $slug => 'yes' ],
      ]
    );

		$ext->add_control(
      'clip_path_amplitude_' . $slug,
      [
        'label'   => esc_html__( 'Amplitude', 'elementary-addons' ),
        'type'    => Controls_Manager::NUMBER,
        'default' => 10,
        // 'selectors' => [
        //   '{{WRAPPER}} ul' => 'grid-template-columns:repeat(auto-fit, minmax({{VALUE}}px, 1fr));',
        // ],
				'condition' => [ 'clip_path_top_on_' . $slug => 'yes' ],
      ]
    );

		$ext->add_control(
      'clip_path_frequency_' . $slug,
      [
        'label'   => esc_html__( 'Frequency', 'elementary-addons' ),
        'type'    => Controls_Manager::NUMBER,
        'default' => 1.5,
				'step' => 0.1,
        // 'selectors' => [
        //   '{{WRAPPER}} ul' => 'grid-template-columns:repeat(auto-fit, minmax({{VALUE}}px, 1fr));',
        // ],
				'condition' => [ 'clip_path_top_on_' . $slug => 'yes' ],
      ]
    );

		$ext->add_control(
      'clip_path_phase_' . $slug,
      [
        'label'   => esc_html__( 'Phase (1-180deg)', 'elementary-addons' ),
        'type'    => Controls_Manager::NUMBER,
        'default' => 10,
				'min' => 1,
				'max' => 180,
        // 'selectors' => [
        //   '{{WRAPPER}} ul' => 'grid-template-columns:repeat(auto-fit, minmax({{VALUE}}px, 1fr));',
        // ],
				'condition' => [ 'clip_path_top_on_' . $slug => 'yes' ],
      ]
    );

		$ext->add_control(
      'clip_path_points_' . $slug,
      [
        'label'   => esc_html__( 'Points', 'elementary-addons' ),
        'type'    => Controls_Manager::NUMBER,
        'default' => 50,
        // 'selectors' => [
        //   '{{WRAPPER}} ul' => 'grid-template-columns:repeat(auto-fit, minmax({{VALUE}}px, 1fr));',
        // ],
				'condition' => [ 'clip_path_top_on_' . $slug => 'yes' ],
      ]
    );

		$ext->add_control(
      'clip_path_bottom_on_' . $slug,
      [
        'label' => esc_html__( 'Apply Clip Path Bottom', 'elementary-addons' ),
        'type' => Controls_Manager::SWITCHER,
        'label_on' => esc_html__( 'Yes', 'elementary-addons' ),
        'label_off' => esc_html__( 'No', 'elementary-addons' ),
        'return_value' => 'yes',
				'default' => '',
      ]
    );

		$ext->add_control(
      'clip_path_offset_bottom_' . $slug,
      [
        'label'   => esc_html__( 'Offset', 'elementary-addons' ),
        'type'    => Controls_Manager::NUMBER,
        'default' => 290,
        // 'selectors' => [
        //   '{{WRAPPER}} ul' => 'grid-template-columns:repeat(auto-fit, minmax({{VALUE}}px, 1fr));',
        // ],
				'condition' => [ 'clip_path_bottom_on_' . $slug => 'yes' ],
      ]
    );

		$ext->add_control(
      'clip_path_amplitude_bottom_' . $slug,
      [
        'label'   => esc_html__( 'Amplitude', 'elementary-addons' ),
        'type'    => Controls_Manager::NUMBER,
        'default' => 10,
        // 'selectors' => [
        //   '{{WRAPPER}} ul' => 'grid-template-columns:repeat(auto-fit, minmax({{VALUE}}px, 1fr));',
        // ],
				'condition' => [ 'clip_path_bottom_on_' . $slug => 'yes' ],
      ]
    );

		$ext->add_control(
      'clip_path_frequency_bottom_' . $slug,
      [
        'label'   => esc_html__( 'Frequency', 'elementary-addons' ),
        'type'    => Controls_Manager::NUMBER,
        'default' => 1.5,
				'step' => 0.1,
        // 'selectors' => [
        //   '{{WRAPPER}} ul' => 'grid-template-columns:repeat(auto-fit, minmax({{VALUE}}px, 1fr));',
        // ],
				'condition' => [ 'clip_path_bottom_on_' . $slug => 'yes' ],
      ]
    );

		$ext->add_control(
      'clip_path_phase_bottom_' . $slug,
      [
        'label'   => esc_html__( 'Phase (1-180deg)', 'elementary-addons' ),
        'type'    => Controls_Manager::NUMBER,
        'default' => 10,
				'min' => 1,
				'max' => 180,
        // 'selectors' => [
        //   '{{WRAPPER}} ul' => 'grid-template-columns:repeat(auto-fit, minmax({{VALUE}}px, 1fr));',
        // ],
				'condition' => [ 'clip_path_bottom_on_' . $slug => 'yes' ],
      ]
    );

		$ext->add_control(
      'clip_path_points_bottom_' . $slug,
      [
        'label'   => esc_html__( 'Points', 'elementary-addons' ),
        'type'    => Controls_Manager::NUMBER,
        'default' => 50,
        // 'selectors' => [
        //   '{{WRAPPER}} ul' => 'grid-template-columns:repeat(auto-fit, minmax({{VALUE}}px, 1fr));',
        // ],
				'condition' => [ 'clip_path_bottom_on_' . $slug => 'yes' ],
      ]
    );
	}

	public function clip_path_controls( $ext ) {


		$ext->start_controls_section(
			'clip_path_settings',
			[
				'label' =>  esc_html__( 'Section Wave Clip', 'elementary-addons' ),
				'tab' => Controls_Manager::TAB_ADVANCED
			]
		);

		$ext->add_control(
			'clip_path_refresh',
			[
				'type' => Controls_Manager::RAW_HTML,
				'raw' => '<button class="elementor-button elementor-button-success braft-custom-css-update-preview-button" onclick="elementor.reloadPreview();">' . esc_html__( 'Refresh', 'elementary-addons' ) . '</button>',

			]
		);

		/////////////////////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////


		$ext->start_controls_tabs( 'clip_path_styles' );

		$ext->start_controls_tab(
			'clip_path_active',
			[
				'label' => esc_html__( 'Desktop', 'elementary-addons' ),
			]
		);

		$this->wave_controls( $ext, 'desktop' );

		$ext->end_controls_tab();

		$ext->start_controls_tab(
			'clip_path_normal',
			[
				'label' => esc_html__( 'Tablet', 'elementary-addons' ),
			]
		);

		$ext->add_control(
			'clip_path_brkpt_tablet_bea',
			[
				'type' => \Elementor\Controls_Manager::NUMBER,
				'label' => esc_html__( 'Breakpoint', 'elementary-addons' ),
				'default' => 1024,
			]
		);

		$this->wave_controls( $ext, 'tablet_bea' );




		$ext->end_controls_tab();


		$ext->start_controls_tab(
			'clip_path_hover',
			[
				'label' => esc_html__( 'Mobile', 'elementary-addons' ),
			]
		);

		$ext->add_control(
			'clip_path_brkpt_mobile_bea',
			[
				'type' => \Elementor\Controls_Manager::NUMBER,
				'label' => esc_html__( 'Breakpoint', 'elementary-addons' ),
				'default' => 768,
			]
		);

		$this->wave_controls( $ext, 'mobile_bea' );

		$ext->end_controls_tab();
		$ext->end_controls_tabs();

		$ext->end_controls_section();
	}



	public function clip_path_before_render( $element ) {

		$el_sett = $element->get_settings();
		$id = $element->get_id();

		$devices = [ 'desktop', 'tablet_bea', 'mobile_bea' ];
		$clip_path_string = '';
		$clip_path = '';

		for ( $i = 0; $i < count( $devices ); $i++ ) {
			if(
				$el_sett['clip_path_top_on_' . $devices[$i]] === 'yes' ||
				$el_sett['clip_path_bottom_on_' . $devices[$i]] === 'yes'
			){

				$width_px = 700;
				$height_px = 300;


		    $inverted = false;

				$pth = '.eafree_section_clip_path_' . $id . '{clip-path: polygon(100% 100%, 0% 100% ';
				$invpth = '.eafree_section_clip_path_' . $id . '{clip-path: polygon(100% 0%, 0% 0% ';

				if( $devices[$i] === 'mobile_bea' || $devices[$i] === 'tablet_bea' ){
					$brkpt = $el_sett['clip_path_brkpt_' . $devices[$i]];
					$path = '@media screen and (max-width:' . $brkpt . 'px){' . $pth;
				  $invertedpath = '@media screen and (max-width:' . $brkpt . 'px){' . $invpth;
				}
				else{
					$path =  $pth;
				  $invertedpath = $invpth;
				}



				if(
					$el_sett['clip_path_top_on_' . $devices[$i]] === 'yes' &&
					$el_sett['clip_path_bottom_on_' . $devices[$i]] !== 'yes'
				){
					$clip_path_string = $path;
				}
				if(
					$el_sett['clip_path_top_on_' . $devices[$i]] !== 'yes' &&
					$el_sett['clip_path_bottom_on_' . $devices[$i]] === 'yes'
				){
					$clip_path_string = $invertedpath;
				}
				else{
					$clip_path_string = $path;
				}

				if( $el_sett['clip_path_top_on_' . $devices[$i]] === 'yes' ){
					$offset = $el_sett['clip_path_offset_' . $devices[$i]];
			    $amplitude = $el_sett['clip_path_amplitude_' . $devices[$i]];
			    $frequency = $el_sett['clip_path_frequency_' . $devices[$i]];
			    $phase = $el_sett['clip_path_phase_' . $devices[$i]];
			    $points = $el_sett['clip_path_points_' . $devices[$i]];
					$units = 2 * pi() * $frequency / $points;
					$rad_phase = $phase * pi() / 180;
					for ($a = 0; $a <= $points; $a++) {
			        $val = $offset + $amplitude * cos($a * $units + $rad_phase);
			        $valY = number_format( $val / $height_px * 100, 2, '.', "" );
			        $valX = number_format( $a * 100 / $points, 2, '.', "" );
			        $clip_path_string .= ', ' . $valX . '% ' . $valY . '%';
			    }
				}

				if( $el_sett['clip_path_bottom_on_' . $devices[$i]] === 'yes' ){
					$offset_bottom = $el_sett['clip_path_offset_bottom_' . $devices[$i]];
			    $amplitude_bottom = $el_sett['clip_path_amplitude_bottom_' . $devices[$i]];
			    $frequency_bottom = $el_sett['clip_path_frequency_bottom_' . $devices[$i]];
			    $phase_bottom = $el_sett['clip_path_phase_bottom_' . $devices[$i]];
			    $points_bottom = $el_sett['clip_path_points_bottom_' . $devices[$i]];
					$units_bottom = 2 * pi() * $frequency_bottom / $points_bottom;
					$rad_phase_bottom = $phase_bottom * pi() / 180;
					$bottom_points = [];
					for ($b = 0; $b <= $points_bottom; $b++) {
			        $val_bottom = $offset_bottom + $amplitude_bottom * cos($b * $units_bottom + $rad_phase_bottom);
			        $valY_bottom = number_format( $val_bottom / $height_px * 100, 2, '.', "" );
			        $valX_bottom = number_format( $b * 100 / $points_bottom, 2, '.', "" );
			        $bottom_points[$b] = ', ' . $valX_bottom . '% ' . $valY_bottom . '%';

			    }
					if(
						$el_sett['clip_path_top_on_' . $devices[$i]] !== 'yes' &&
						$el_sett['clip_path_bottom_on_' . $devices[$i]] === 'yes'
					){
						$bottom_points_final = $bottom_points;
					}
					else{
						$bottom_points_final = array_reverse( $bottom_points );
						array_push($bottom_points_final, ',0% 100%');
					}

					$clip_path_string .= implode( '', $bottom_points_final );
				}

				if( $devices[$i] === 'mobile_bea' || $devices[$i] === 'tablet_bea' ){
					$clip_path_string .= ');}}';
				}
				else{
					$clip_path_string .= ');}';
				}

				$clip_path .= $clip_path_string;
			} // if top or bottom === yes


		} // for


		$css = trim( $clip_path );
		// if( ! empty( $css ) ){
		// 	// $css = $pcss->get_element_unique_selector( $element ) . '{' . $css . '}';
		// 	$css = str_replace( 'selector', $pcss->get_element_unique_selector( $element ), $css );
		// 	// error_log( $css, 3, dirname( __FILE__ ) . '/clippath.log' );
		// 	$css = sprintf( '/* EA Section Clip Path CSS %s, class: %s */', $element->get_name(), $element->get_unique_selector() ) . $css . '/* End EA Section Clip Path CSS */';
		// 	$pcss->get_stylesheet()->add_raw_css( $css );
		// }

		$element->add_render_attribute( '_wrapper', [
			'class' => 'eafree_section_clip_path eafree_section_clip_path_' . $id,
			] );
			?>
			<style media="screen">
				<?php
					echo wp_kses( $css, 'post' );
				?>
			</style>
			<?php

	}

	public function clip_path_print_template( $template, $widget ) {

		ob_start();
		?>

		<div
		class="eafree_section_clip_path"
		>
		</div>
		<?php
		$content = ob_get_contents();

		ob_end_clean();

		return $template . $content;
	}

}

new EAFREE_Section_Clip_Path();
